#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <linux/input.h>
#include <linux/uinput.h>

static  struct uinput_user_dev udev_spec = {
        .name = "ACPI hotkey",
};

int main(int argc, char** argv) {
	int fd;
	int i, j, key;
	struct input_event event;

	if (argc == 2) {
		key = atoi(argv[1]);
	} else {
		return 1;
	}

	fd = open ("/dev/input/uinput",O_RDWR);
	
	j = ioctl (fd, UI_SET_EVBIT, EV_KEY) < 0;
        j |= ioctl (fd, UI_SET_EVBIT, EV_REP) < 0;
        for (i = KEY_RESERVED; i < BTN_MISC; i++)
                j |= ioctl (fd, UI_SET_KEYBIT, i) < 0;


	write(fd, &udev_spec, sizeof udev_spec);

	ioctl (fd, UI_DEV_CREATE, 0);

	event.type = EV_KEY;
	event.code = key;
	event.value = 1;
	write(fd, &event, sizeof event);

	event.type = EV_KEY;
	event.code = key;
	event.value = 0;
	write(fd, &event, sizeof event);
	
	return 0;
}

